using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Common;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DynamicProvider
{
	public partial class Form1 : Form
	{
		DataTable m_product;
		DataTable m_providers;

		public Form1()
		{
			InitializeComponent();
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			m_providers = DbProviderFactories.GetFactoryClasses();
			m_providers.TableName = "Providers";
			dgProviders.DataSource = m_providers;
		}

		private void btnPopulate_Click(object sender, EventArgs e)
		{
			// Of course this only works if user selected the SQL provider

			string pName;
			pName = m_providers.Rows[dgProviders.CurrentRow.Index]["InvariantName"].ToString();
			DbProviderFactory factory = DbProviderFactories.GetFactory(pName);
			DbConnection conn = factory.CreateConnection();
			conn.ConnectionString = "Data Source=WXPVM;Initial Catalog=AdventureWorks;Integrated Security=True";
			DbCommand comm = conn.CreateCommand();
			comm.CommandText = "Select * from Production.Product";

			m_product = new DataTable();
			m_product.TableName = "Product";

			using (conn)
			{
				conn.Open();
				DbDataReader reader = comm.ExecuteReader();

				m_product.Load(reader);
			}

			dgProduct.DataSource = m_product;
		}

	}
}